## crash 7.2.9

=== debian/changelog ===
crash (7.2.9-2ubuntu2) hirsute; urgency=medium

  * Build without lto. Fails to build gdb on ppc64el. That should be fixed,
    once gdb is updated to a more recent version (e.g. 10.x).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Mar 2021 10:04:06 +0100

crash (7.2.9-2ubuntu1) hirsute; urgency=medium

  * Merge with Debian; remaining changes:

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Mar 2021 09:08:04 +0100

crash (7.2.9-2) unstable; urgency=medium

  * Backporting future patches to support printk in kernel 5.10+ based on:
    https://github.com/crash-utility/crash/compare/bf57c44...71e159c
  * Update to current debhelper 13. 

 -- Troy Heber <troyh@debian.org>  Tue, 08 Dec 2020 12:58:57 -0700

crash (7.2.9-1) unstable; urgency=medium

  * Patch from Sebastian Andrzej Siewior <sebastian@breakpoint.cc>: The crash
    project moved recently to github. The attached patch updates the
    information within the package. It also adds a watch file which points to
    the latest release (closes: #976195)

  * Fix for an ARM64 gcc-10 compilation error.  Without the patch, the build
    of the embedded gdb module fails with an error message that indicates
    "multiple definition of 'tdesc_aarch64'".

  * Fix for the "log" command.  Without the patch, the command's output may be
    truncated, ending with the error message "log: invalid log_buf entry
    encountered".

  * Fix to allow the translation of ARM64 FIXMAP addresses located in the
    virtual memory region between the end of the vmalloc region and the
    beginning of the vmemmap region.  Without the patch, reads of virtual
    addresses within that region are not recognized properly and will fail.

  * Introduction of a new "extend -s" option, which shows all available shared
    object extension modules that are located in the directories that are part
    of the normal search path that is used when a shared object is loaded
    without a fully-qualified pathname.

  * Fix for the "bpf -m|-M" options on Linux 5.3 and later kernels that
    contain commit 3539b96e041c06e4317082816d90ec09160aeb11, titled "bpf:
    group memory related fields in struct bpf_map_memory".  Without the patch,
    the options prints "(unknown)" for MEMLOCK and UID.

  * Enhancement to the "bpf -p|-P" options to display the eBPF program name
    string.

  * Fix for reading compressed kdump dumpfiles from systems with physical
    memory located at extraordinarily high addresses.  In a system with a
    physical address range from 0x602770ecf000 to 0x6027ffffffff, the crash
    utility fails during session initialization due to an integer overflow,
    ending with the error message "crash: vmlinux and vmcore do not match!".

  * Enhancement of the "struct -r" option to support the raw memory display of
    a single data structure member.  Without the patch, the option only
    supported the raw display of a complete data structure.

  * Modify the display behavior of the "struct -r" option so as to scale the
    minimum display size from the size of a per-architecture long (32-bits or
    64-bits) down to 8-bits, 16-bits or 32-bits when the requested size is
    equal to one of the smaller sizes.

  * Introduce a new ARM64 "--machdep vabits_actual=<value>" command line
    option for Linux 5.4 and later dumpfiles, which require the kernel's
    dynamically-determined "vabits_actual" value for virtual address
    translation.  Without the patch, the crash session fails during
    initialization with the error message "crash: cannot determine
    VA_BITS_ACTUAL".  This option will become unnecessary when the proposed
    TCR_EL1.T1SZ vmcoreinfo entry is incorporated into the kernel.

  * Fix for "kmem -[sS]" options on Linux 4.14 and later kernels built with
    CONFIG_SLAB_FREELIST_HARDENED enabled. Without the patch, there will error
    messages of the type "kmem: <cache name> slab: <address> invalid
    freepointer: <obfuscated address>" for caches created during SLUB
    bootstrap, as they are likely to have s->random == 0.

  * If readmem() receives a user-space address in a page that has been swapped
    to the zswap compressed swap cache, an attempt will be made to find and
    decompress the page.

  * Fix for the "mount -n [pid|task]" option when running on a live system.
    Without the patch, if the [pid|task] has been created since the last
    internal task table refresh, the command fails with the error message
    "mount: invalid task or pid value: <value>".

  * Introduction of the "log -T" option, which translates the leading
    timestamp value of each message into human readable format.

  * When kernels are built with LLVM, the names of many symbols may be
    appended with an ".llvm.<number>" string.  As a result, commands such as
    "irq" fail with the error message irq: neither irq_desc, _irq_desc,
    irq_desc_ptrs or irq_desc_tree symbols exist".  This patch adds the
    LLVM-generated string to the other strings that are stripped from symbols
    before they are stored.

  * Prepare for the introduction of ARM64 8.3 Pointer Authentication as
    in-kernel feature.  The value of CONFIG_ARM64_KERNELPACMASK will be
    exported as a vmcoreinfo entry, and will be used with text return
    addresses on the kernel stack.

  * Several fixes for ARM64 kernels:
    (1) Linux kernel patch "arm64: mm: Introduce vabits_actual"
        introduced "physvirt_offset", which is not equal to
        (PHYS_OFFSET - PAGE_OFFSET) when KASLR is enabled.
        physvirt_offset is caculated in arch/arm64/mm/init.c
        before memstart_addr (PHYS_OFFSET) is randomized.  Let
        arm64_VTOP() and arm64_PTOV() use physvirt_offset instead,
        whose default value is set to (phys_offset - page_offset)
    (2) For ARM64 RAM dumps without any vmcoreinfo and KASLRpassed as
        argument, " _stext_vmlinux" is not set.  This causes incorrect
        calculation of vmalloc_start with VA_BITS_ACTUAL.


=== debian/control ===
Source: crash
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
Uploaders:
Build-Depends: debhelper (>= 13), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
Standards-Version: 4.5.0.0
Homepage: https://crash-utility.github.io/
XS-Testsuite: autopkgtest

Package: crash
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils
Suggests: kexec-tools, makedumpfile
Description: kernel debugging utility, allowing gdb like syntax
 The core analysis suite is a self-contained tool that can be used to
 investigate either live systems, or multiple different core dump formats
 including kdump, LKCD, netdump and diskdump.
 .
 o  The tool is loosely based on the SVR4 crash command, but has been
    completely integrated with gdb in order to be able to display
    formatted kernel data structures, disassemble source code, etc.
 .
 o  The current set of available commands consist of common kernel core
    analysis tools such as a context-specific stack traces, source code
    disassembly, kernel variable displays, memory display, dumps of
    linked-lists, etc.  In addition, any gdb command may be entered,
    which in turn will be passed onto the gdb module for execution.
 .
 o  There are several commands that delve deeper into specific kernel
    subsystems, which also serve as templates for kernel developers
    to create new commands for analysis of a specific area of interest.
    Adding a new command is a simple affair, and a quick recompile
    adds it to the command menu.
 .
 o  The intent is to make the tool independent of Linux version dependencies,
    building in recognition of major kernel code changes so as to adapt to
    new kernel versions, while maintaining backwards compatibility.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto
export EXTDIR=/usr/lib/crash/extensions
DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	$(MAKE) extensions lzo snappy

override_dh_auto_clean:
	cp $(CURDIR)/Makefile $(CURDIR)/debian/Makefile.ori
	dh_auto_clean

override_dh_clean:
	dh_clean
	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
	rm -Rf $(CURDIR)/configure
	rm -Rf $(CURDIR)/gdb-7.6
	rm -Rf $(CURDIR)/gdb.files
	rm -Rf $(CURDIR)/build_data.c
	rm -Rf $(CURDIR)/extensions/*.so
	rm -Rf $(CURDIR)/CFLAGS.extra
	rm -Rf $(CURDIR)/LDFLAGS.extra
	rm -Rf $(CURDIR)/extensions/defs.h

override_dh_auto_install:
	dh_auto_install
	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
	mkdir -p $(CURDIR)/debian/crash$(EXTDIR)
	cp -p extensions/*.so $(CURDIR)/debian/crash$(EXTDIR)

override_dh_auto_test:
	# Crash does not provide a testsuite

## crash 7.3.0

=== debian/changelog ===
crash (7.3.0-1ubuntu1) impish; urgency=medium

  * Merge with Debian; remaining changes:
    - Build without lto. Fails to build gdb on ppc64el. That should be fixed,
      once gdb is updated to a more recent version (e.g. 10.x).
    - Add linux-libc-dev dependency for the autopkg test. This package
      gets usually broken with kernel upgrades, so let it already show
      in the autopkg test.

 -- dann frazier <dann.frazier@canonical.com>  Thu, 08 Jul 2021 09:16:21 -0600

crash (7.3.0-1) experimental; urgency=medium

  * Add support for new lockless righbuffer that Linux 5.10 introduced.
    Without the two patches, crash fails during session initialization or
    "log" command fails with the error message:

    crash: cannot determine length of symbol: log_end

  * Add support for VC exception stack on x86_64 Linux 5.10 and later kernels
    that contain commit 02772fb9b68e ("x86/sev-es: Allocate and map an IST
    stack for #VC handler").

  * Fix regression for raw RAM dumpfiles.  Commit f42db6a33f0e ("Support core
    files with "unusual" layout") increased the minimal file size from
    MIN_NETDUMP_ELF_HEADER_SIZE to SAFE_NETDUMP_ELF_HEADER_SIZE which can lead
    to crash rejecting raw RAM dumpfiles.  Without the patch, the crash fails
    to start a session with the error message:

    /var/tmp/ramdump_elf_XXXXXX: ELF header read: No such file or directory
    crash: malformed ELF file: /var/tmp/ramdump_elf_XXXXXX


  * Update mapping symbol filter in arm64_verify_symbol() to support the long
    form of mapping symbols, e.g. "$x.<any...>".  Without the patch, the "dis"
    command cannot completely parse out the disassembly of a function that has
    mapping symbols in the long form and misses the tail part of the function.

  * Move extensins/Makefile's ping check to recipe script.  Without this
    patch, in an environment where ping to github.com does not work, "make
    clean" at the top-level crash directory always takes about 10 seconds
    unnecessarily.

  * Fix for a segmentation fault when analyzing arm64 kernels that are
    configured with CONFIG_IKCONFIG and have a strange entry that does not
    contain the delimiter "=", such as "CONFIG_SECU+[some hex data]".  Without
    the patch, in the add_ikconfig_entry() function, strtok_r() interprets it
    as consisting of a single token and the val variable is set to NULL, and
    then strdup() crashes.

  * Fix a couple of issues that were detected by valgrind.

  * Add ability to un-set scope.  The ability can come in very useful when
    running automated pykdump scripts and needing scope to be cleared between
    script runs.

  * Fix "sys [-t]|mod -S" after "mod -t" when crash runs with -s option.
    Without the patch, the "sys [-t]" and "mod -S" options after "mod -t"
    option fail with the error message:

    sys: invalid structure member offset: tnt_false FILE: kernel.c  LINE:
    11203  FUNCTION: show_kernel_taints_v4_10()

  * Fix for "dev -d" option on Linux 5.11-rc1 and later kernels that contains
    commit 0d02129e76edf91cf04fabf1efbc3a9a1f1d729a ("block: merge struct
    block_device and struct hd_struct").  Without the patch, the option fails
    with the error message: 

    dev: invalid structure member offset: hd_struct_dev

  * Fix for "kmem -v" option on Linux 5.11-rc1 and later kernels that contain
    commit 96e2db456135db0cf2476b6890f1e8b2fdcf21eb ("mm/vmalloc: rework the
    drain logic").  Without the patch, the option will display nothing or fail
    with the error message:

    kmem: invalid kernel virtual address: <address>  type: "vmlist addr"

  * Add the base address of module to "mod" command output.  Currently the
    command shows the address of the module struct, but it is inconvenient to
    know the address range of the module, so extend to show the base address.

  * Increase the value of __PHYSICAL_MASK_SHIFT_XEN to 52.  The former value
    of __PHYSICAL_MASK_SHIFT_XEN in crash (40) is smaller than the kernel (52)
    since kernel commit 6f0e8bf167 (xen: support 52 bit physical addresses in
    pv guests).  This can cause x86_64_pud_offset() to lose the most
    significant bits of pgd_pte, leading to a failed xen_m2p() translation,
    resulting in crash failing with an error message like this:

    crash: read error: physical address: ffffffffffffffff  type: "pud page"

  * Change log level print in older kernels.  In older kernels that have the
    variable-length-record log_buf, the log level and the log flags/facility
    are not separated.  Since the log level is only the last three bits, and
    the flags/facility and level are separated in
    5.10 and later kernels, only print those last three bits when using 'log
    -m'.

  * Reduce crash build log.  The verbose output of tar command when extracting
    the GDB source files occupies more than the half of crash build log.  It
    is not so helpful and makes the build log longer needlessly especially on
    CI build test without the patch.

  * Fix for "bt" command on Linux 5.12-rc1 and later x86_64 kernels that
    contain commit 951c2a51ae75 ("x86/irq/64: Adjust the per CPU irq stack
    pointer by 8").  Without the patch, the "bt" command and some of its
    options that read irq stack fail with the error message:

    bt: read of stack at <address> failed".

  * Add valgrind support for the crash's custom memory allocator.  This helps
    detecting various memory errors on the crash's custom memory allocator.

  * Fix for a couple of invalid read/write issues detected by valgrind.

  * Fix "struct" command to print member array of list_heads correctly.
    Without the patch, due to the way that an array of list_head entries are
    printed, parsing of them fails and the command does not print anything:

    crash> struct blk_mq_ctx.rq_completed ffffc447ffc0f740 crash>

  * Do not pass through 'sy' command to GDB.  The GDB 'symbol-file' command is


=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
 Build-Depends: debhelper (>= 13), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
-Standards-Version: 4.5.0.0
+Standards-Version: 4.5.1.0
 Homepage: https://crash-utility.github.io/
 XS-Testsuite: autopkgtest

=== debian/tests/control ===
Tests: live
Restrictions: needs-root isolation-machine
Depends: @, lsb-release, software-properties-common, sudo, linux-libc-dev

## crash 8.0.0

=== Makefile ===
# Makefile for core analysis suite
#
# Copyright (C) 1999, 2000, 2001, 2002 Mission Critical Linux, Inc.
#       www.missioncriticallinux.com, info@missioncriticallinux.com
#
# Copyright (C) 2002-2016 David Anderson
# Copyright (C) 2002-2016 Red Hat, Inc. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

PROGRAM=crash

#
# Supported targets: X86 ALPHA PPC IA64 PPC64 SPARC64
# TARGET and GDB_CONF_FLAGS will be configured automatically by configure
#
TARGET=
GDB_CONF_FLAGS=

ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
ifeq (${ARCH}, ppc64)
CONF_FLAGS = -m64
endif

#
# GDB, GDB_FILES, GDB_OFILES and GDB_PATCH_FILES will be configured automatically by configure 
#
GDB=
GDB_FILES=
GDB_OFILES=
GDB_PATCH_FILES=

#
# Default installation directory
#
INSTALLDIR=${DESTDIR}/usr/bin

# LDFLAGS will be configured automatically by configure
LDFLAGS=

GENERIC_HFILES=defs.h xen_hyper_defs.h xen_dom0.h
MCORE_HFILES=va_server.h vas_crash.h
REDHAT_HFILES=netdump.h diskdump.h makedumpfile.h xendump.h kvmdump.h qemu-load.h vmcore.h
LKCD_DUMP_HFILES=lkcd_vmdump_v1.h lkcd_vmdump_v2_v3.h lkcd_dump_v5.h \
        lkcd_dump_v7.h lkcd_dump_v8.h
LKCD_OBSOLETE_HFILES=lkcd_fix_mem.h
LKCD_TRACE_HFILES=lkcd_x86_trace.h
IBM_HFILES=ibm_common.h
SADUMP_HFILES=sadump.h
UNWIND_HFILES=unwind.h unwind_i.h rse.h unwind_x86.h unwind_x86_64.h
VMWARE_HFILES=vmware_vmss.h

CFILES=main.c tools.c global_data.c memory.c filesys.c help.c task.c \
	kernel.c test.c gdb_interface.c configure.c net.c dev.c bpf.c \
	printk.c \
	alpha.c x86.c ppc.c ia64.c s390.c s390x.c s390dbf.c ppc64.c x86_64.c \
	arm.c arm64.c mips.c mips64.c sparc64.c \
	extensions.c remote.c va_server.c va_server_v1.c symbols.c cmdline.c \
	lkcd_common.c lkcd_v1.c lkcd_v2_v3.c lkcd_v5.c lkcd_v7.c lkcd_v8.c\
	lkcd_fix_mem.c s390_dump.c lkcd_x86_trace.c \
	netdump.c diskdump.c makedumpfile.c xendump.c unwind.c unwind_decoder.c \
	unwind_x86_32_64.c unwind_arm.c \
	xen_hyper.c xen_hyper_command.c xen_hyper_global_data.c \
	xen_hyper_dump_tables.c kvmdump.c qemu.c qemu-load.c sadump.c ipcs.c \
	ramdump.c vmware_vmss.c vmware_guestdump.c \
	xen_dom0.c kaslr_helper.c

SOURCE_FILES=${CFILES} ${GENERIC_HFILES} ${MCORE_HFILES} \
	${REDHAT_CFILES} ${REDHAT_HFILES} ${UNWIND_HFILES} \
	${LKCD_DUMP_HFILES} ${LKCD_TRACE_HFILES} ${LKCD_OBSOLETE_HFILES}\
	${IBM_HFILES} ${SADUMP_HFILES} ${VMWARE_HFILES}

OBJECT_FILES=main.o tools.o global_data.o memory.o filesys.o help.o task.o \
	build_data.o kernel.o test.o gdb_interface.o net.o dev.o bpf.o \
	printk.o \
	alpha.o x86.o ppc.o ia64.o s390.o s390x.o s390dbf.o ppc64.o x86_64.o \
	arm.o arm64.o mips.o mips64.o sparc64.o \
	extensions.o remote.o va_server.o va_server_v1.o symbols.o cmdline.o \
	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
	lkcd_fix_mem.o s390_dump.o netdump.o diskdump.o makedumpfile.o xendump.o \
	lkcd_x86_trace.o unwind_v1.o unwind_v2.o unwind_v3.o \
	unwind_x86_32_64.o unwind_arm.o \
	xen_hyper.o xen_hyper_command.o xen_hyper_global_data.o \
	xen_hyper_dump_tables.o kvmdump.o qemu.o qemu-load.o sadump.o ipcs.o \
	ramdump.o vmware_vmss.o vmware_guestdump.o \
	xen_dom0.o kaslr_helper.o

MEMORY_DRIVER_FILES=memory_driver/Makefile memory_driver/crash.c memory_driver/README

# These are the current set of crash extensions sources.  They are not built
# by default unless the third command line of the "all:" stanza is uncommented.
# Alternatively, they can be built by entering "make extensions" from this
# directory.

EXTENSIONS=extensions
EXTENSION_SOURCE_FILES=${EXTENSIONS}/Makefile ${EXTENSIONS}/echo.c ${EXTENSIONS}/dminfo.c \
	${EXTENSIONS}/snap.c ${EXTENSIONS}/snap.mk ${EXTENSIONS}/trace.c \
	${EXTENSIONS}/eppic.c ${EXTENSIONS}/eppic.mk

DAEMON_OBJECT_FILES=remote_daemon.o va_server.o va_server_v1.o \
	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
	s390_dump.o netdump_daemon.o

GDB_5.0_FILES=${GDB}/gdb/Makefile.in \
	  ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
	  ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
	  ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
	  ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/gnu-regex.c \
	  ${GDB}/gdb/ppc-linux-nat.c
GDB_5.0_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/gnu-regex.o \
          ${GDB}/gdb/ppc-linux-nat.o

GDB_5.1_FILES=${GDB}/gdb/Makefile.in \
	  ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
	  ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
	  ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
	  ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c  ${GDB}/gdb/gnu-regex.c
GDB_5.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/gnu-regex.o

GDB_5.2.1_FILES=${GDB}/gdb/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c
GDB_5.2.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o 

GDB_5.3post-0.20021129.36rh_FILES=${GDB}/gdb/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/frame.c ${GDB}/gdb/alpha-tdep.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/dwarf2read.c
GDB_5.3post-0.20021129.36rh_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/frame.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o ${GDB}/gdb/ui-file.o \
          ${GDB}/gdb/utils.o ${GDB}/gdb/dwarf2read.o

GDB_6.0_FILES=${GDB}/gdb/Makefile.in ${GDB}/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c \
	  ${GDB}/gdb/ppc-linux-tdep.c ${GDB}/sim/ppc/ppc-instructions \
	  ${GDB}/bfd/simple.c ${GDB}/include/obstack.h
GDB_6.0_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o \
	  ${GDB}/gdb/ppc-linux-tdep.o ${GDB}/bfd/simple.o

GDB_6.1_FILES=${GDB}/gdb/Makefile.in ${GDB}/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/dwarf2read.c \
          ${GDB}/include/obstack.h ${GDB}/gdb/ppc-linux-tdep.c
GDB_6.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/dwarf2read.o \
          ${GDB}/gdb/ppc-linux-tdep.o

GDB_7.0_FILES=
GDB_7.0_OFILES=${GDB}/gdb/symtab.o

GDB_7.3.1_FILES=
GDB_7.3.1_OFILES=${GDB}/gdb/symtab.o

GDB_7.6_FILES=
GDB_7.6_OFILES=${GDB}/gdb/symtab.o

GDB_10.2_FILES=
GDB_10.2_OFILES=${GDB}/gdb/symtab.o

# 
# GDB_FLAGS is passed up from the gdb Makefile.
#
GDB_FLAGS=

#
# WARNING_OPTIONS and WARNING_ERROR are both applied on a per-file basis. 
# WARNING_ERROR is NOT used on files including "dirty" gdb headers so that 
# successful compilations can be achieved with acceptable warnings; its 
# usefulness is also dependent upon the processor's compiler -- your mileage
# may vary.
#
#WARNING_OPTIONS=-Wall -O2 -Wstrict-prototypes -Wmissing-prototypes -fstack-protector -Wformat-security
#WARNING_ERROR=-Werror

# TARGET_CFLAGS will be configured automatically by configure
TARGET_CFLAGS=

CRASH_CFLAGS=-g -D${TARGET} ${TARGET_CFLAGS} ${GDB_FLAGS} ${CFLAGS}

GPL_FILES=
TAR_FILES=${SOURCE_FILES} Makefile ${GPL_FILES} README .rh_rpm_package crash.8 \
	${EXTENSION_SOURCE_FILES} ${MEMORY_DRIVER_FILES}
CSCOPE_FILES=${SOURCE_FILES}

READLINE_DIRECTORY=./${GDB}/readline/readline
BFD_DIRECTORY=./${GDB}/bfd
GDB_INCLUDE_DIRECTORY=./${GDB}/include

REDHATFLAGS=-DREDHAT

# target could be set on command line when invoking make. Like: make target=ARM
# otherwise target will be the same as the host
ifneq ($(target),)
CONF_TARGET_FLAG="-t$(target)"
endif

# To build the extensions library by default, uncomment the third command
# line below.  Otherwise they can be built by entering "make extensions".

all: make_configure
	@./configure ${CONF_TARGET_FLAG} -p "RPMPKG=${RPMPKG}" -b
	@make --no-print-directory gdb_merge
#	@make --no-print-directory extensions

gdb_merge: force
	@if [ ! -f ${GDB}/README ]; then \
	  make --no-print-directory gdb_unzip; fi
	@echo "${LDFLAGS} -lz -ldl -rdynamic" > ${GDB}/gdb/mergelibs
	@echo "../../${PROGRAM} ../../${PROGRAM}lib.a" > ${GDB}/gdb/mergeobj
	@rm -f ${PROGRAM}
	@if [ ! -f ${GDB}/config.status ]; then \
	  (cd ${GDB}; ./configure ${GDB_CONF_FLAGS} --with-separate-debug-dir=/usr/lib/debug \
	    --with-bugurl="" --with-expat=no --with-python=no --disable-sim; \
	  make --no-print-directory CRASH_TARGET=${TARGET}; echo ${TARGET} > crash.target) \
	else make --no-print-directory rebuild; fi
	@if [ ! -f ${PROGRAM} ]; then \
	  echo; echo "${PROGRAM} build failed"; \
	  echo; exit 1; fi

rebuild:
	@if [ ! -f ${GDB}/${GDB}.patch ]; then \
	  touch ${GDB}/${GDB}.patch; fi
	@if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ] && \
	  [ "`sum ${GDB}.patch`" != "`sum ${GDB}/${GDB}.patch`" ]; then \
	  (sh -x ${GDB}.patch ${TARGET}; patch -N -p0 -r- --fuzz=0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
	  make --no-print-directory CRASH_TARGET=${TARGET}) \
	else (cd ${GDB}/gdb; make --no-print-directory CRASH_TARGET=${TARGET}); fi

gdb_unzip:
	@rm -f gdb.files
	@for FILE in ${GDB_FILES} dummy; do\
	  echo $$FILE >> gdb.files; done
	@if [ ! -f ${GDB}.tar.gz ] && [ ! -f /usr/bin/wget ]; then \
	  echo /usr/bin/wget is required to download ${GDB}.tar.gz; echo; exit 1; fi
	@if [ ! -f ${GDB}.tar.gz ] && [ -f /usr/bin/wget ]; then \
	  [ ! -t 2 ] && WGET_OPTS="--progress=dot:mega"; \
	  wget $$WGET_OPTS http://ftp.gnu.org/gnu/gdb/${GDB}.tar.gz; fi
	@tar --exclude-from gdb.files -xzmf ${GDB}.tar.gz
	@make --no-print-directory gdb_patch

gdb_patch:
	if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ]; then \
		patch -p0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; fi

library: make_build_data ${OBJECT_FILES}
	ar -rs ${PROGRAM}lib.a ${OBJECT_FILES}

gdb: force
	rm -f ${GDB_OFILES}
	@make --no-print-directory all

force:
	

make_configure: force
	@rm -f configure
	@${CC} ${CONF_FLAGS} -o configure configure.c ${WARNING_ERROR} ${WARNING_OPTIONS}

clean: make_configure
	@./configure ${CONF_TARGET_FLAG} -q -b
	@make --no-print-directory do_clean

do_clean:
	rm -f ${OBJECT_FILES} ${DAEMON_OBJECT_FILES} ${PROGRAM} ${PROGRAM}lib.a ${GDB_OFILES}
	@(cd extensions; make --no-print-directory -i clean)
	@(cd memory_driver; make --no-print-directory -i clean)

make_build_data: force
	${CC} -c ${CRASH_CFLAGS} build_data.c ${WARNING_OPTIONS} ${WARNING_ERROR}

install:
	/usr/bin/install -d ${INSTALLDIR}
	/usr/bin/install ${PROGRAM} ${INSTALLDIR}

=== debian/changelog ===
crash (8.0.0-1ubuntu1) jammy; urgency=medium

  * Merge with Debian; remaining changes:
    - Build without lto. Fails to build gdb on ppc64el. That should be fixed,
      once gdb is updated to a more recent version (e.g. 10.x).
    - Add linux-libc-dev dependency for the autopkg test. This package
      gets usually broken with kernel upgrades, so let it already show
      in the autopkg test.
  * Run autopkg test with allow-stderr.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 23 Mar 2022 15:07:01 +0100

crash (8.0.0-1) unstable; urgency=medium
  * New upstream (Closes: #950544)
  * Add lintian override for zlib in embedded gdb
  * 
  * commit ec568e2ea515b66343d3488d5d4b9a625d55b7ae
  * Author: Kazuhito Hagio <k-hagio-ab@nec.com>
  * Date:   Wed Nov 24 13:32:49 2021 +0900
  * 
  *     crash-7.3.0 -> crash-8.0.0
  *     
  *     Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit 6bc104059b124ecac5c8244f84aae6d7cfdfe97c
  * Author: Kazuhito Hagio <k-hagio-ab@nec.com>
  * Date:   Tue Nov 16 02:42:23 2021 +0000
  * 
  *     log: add warning to help text to inform the inaccuracy of -T option
  *     
  *     The timestamps of the "log -T" option are inaccurate because they are
  *     from local_clock(), which returns the raw counter in the local CPU and
  *     it's different from the elapsed wall time.
  *     
  *     The dmesg command, which the "log -T" option imitates, has a similar
  *     behavior in nature and a warning in its help text.  Let's add a warning
  *     also to the crash's help text to inform the inaccuracy for now.
  *     
  *     Reported-by: Martin Moore <martin.moore@hpe.com>
  *     Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit b0dd73d2368275e101688b2aca0bc297fd1ba300
  * Author: Aaron Tomlin <atomlin@redhat.com>
  * Date:   Mon Nov 1 11:39:34 2021 +0000
  * 
  *     kernel: show that the kernel is tainted at init-time
  *     
  *     Explicitly indicate to the user that the Linux kernel is tainted
  *     at init-time or when the 'sys' command is used.
  *     
  *     Signed-off-by: Aaron Tomlin <atomlin@redhat.com>
  * 
  * commit 64f48ee6719632895cd8a0922e84a4626e3790d8
  * Author: Aaron Tomlin <atomlin@redhat.com>
  * Date:   Mon Nov 1 11:39:33 2021 +0000
  * 
  *     kernel: Introduce is_kernel_tainted()
  *     
  *     Provide a quick way to test if the given Linux kernel is "tainted".
  *     Support for Linux-2.6.12 and above, to date.
  *     
  *     Signed-off-by: Aaron Tomlin <atomlin@redhat.com>
  * 
  * commit bfa596f40650e5a061b15d41b0a5b108610b11e9
  * Author: Aaron Tomlin <atomlin@redhat.com>
  * Date:   Mon Nov 1 11:39:32 2021 +0000
  * 
  *     kernel: consolidate show_kernel_taints()
  *     
  *     No functional change.
  *     
  *     Signed-off-by: Aaron Tomlin <atomlin@redhat.com>
  * 
  * commit 8246dce99dd23457e8c7a3fe9609c706694d1959
  * Author: Kazuhito Hagio <k-hagio-ab@nec.com>
  * Date:   Thu Nov 11 15:20:52 2021 +0900
  * 
  *     arm64: Update SECTION_SIZE_BITS for kernels >= 5.12
  *     
  *     Update the default SECTION_SIZE_BITS value for arm64 Linux 5.12
  *     and later kernels that contain kernel commit f0b13ee23241
  *     ("arm64/sparsemem: reduce SECTION_SIZE_BITS").
  *     
  *     Reported-by: Ankur Bansal <er.ankurbansal@gmail.com>
  *     Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit 01d20ca1861ffaf449c1c60aa0536e9f42200ad3
  * Author: Philipp Rudo <prudo@redhat.com>
  * Date:   Tue Nov 9 14:52:22 2021 +0100
  * 
  *     Fix live debugging with lockdown=integrity
  *     
  *     With kernel lockdown the access to kernel interfaces that allow one to
  *     extract confidential information (lockdown=confidentiality) or modify a
  *     running kernel (lockdown=integrity) can be restricted. Two of the
  *     interfaces that can be restricted are /dev/mem (integrity &
  *     confidentiality) and /proc/kcore (confidentiality). With
  *     lockdown=integrity this leads to a situation where /dev/mem exists but
  *     is not readable while /proc/kcore exists and is readable. This breaks
  *     crash's live debugging when it is invoked without argument, i.e.
  *     
  *     $ crash
  *     [...]
  *     crash: /dev/mem: Operation not permitted
  *     
  *     while passing /proc/kcore as image succeeds. The reason for this is
  *     that crash always picks /dev/mem as source when it exits but doesn't
  *     check if it is readable. Fix this by only selecting /dev/mem when it
  *     is readable.
  *     
  *     Signed-off-by: Philipp Rudo <prudo@redhat.com>
  * 
  * commit 68870c83d299603c07785e3530e33c13045c87ef
  * Author: Alexander Egorenkov <egorenar@linux.ibm.com>
  * Date:   Wed Oct 13 10:56:39 2021 +0200
  * 
  *   Handle task_struct cpu member changes for kernels >= 5.16-rc1
  *     
  *   Kernel commit bcf9033e5449bdcaa9bed46467a7141a8049dadb
  *   ("sched: move CPU field back into thread_info if THREAD_INFO_IN_TASK=y")
  *   moved the member cpu of task_struct back into thread_info.
  *   Without the patch, crash fails with the following error message
  *   during session initialization:
  *     
  *     crash: invalid structure member offset: task_struct_cpu
  *            FILE: task.c  LINE: 2904  FUNCTION: add_context()
  *     
  *   Signed-off-by: Alexander Egorenkov <egorenar@linux.ibm.com>
  *    Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit c180a63f2cb370da6097ad97eb07333c07aa988b
  * Author: Kazuhito Hagio <k-hagio-ab@nec.com>
  * Date:   Mon Oct 25 16:53:26 2021 +0900
  * 
  *     arm64: Use VA_BITS for page_offset calculation
  *     
  *     Commit 167d37e347fe ("arm64: assign page_offset with VA_BITS kernel
  *     configuration value") changed the page_offset calculation from
  *     using VA_BITS_ACTUAL to CONFIG_ARM64_VA_BITS.  This caused an error
  *     for ramdumps without vmcoreinfo like this:
  *     
  *       crash: vmlinux and /var/tmp/ramdump_elf_XUtCMT do not match!
  *     


=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
-Build-Depends: debhelper (>= 13), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
+Build-Depends: debhelper (>= 13), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev, libzstd-dev, texinfo
 Standards-Version: 4.5.1.0
 Homepage: https://crash-utility.github.io/
 XS-Testsuite: autopkgtest

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	$(MAKE) extensions lzo snappy
+	$(MAKE) extensions lzo snappy zstd
 
 override_dh_auto_clean:
 	cp $(CURDIR)/Makefile $(CURDIR)/debian/Makefile.ori
@@ -23,7 +23,7 @@
 	dh_clean
 	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
 	rm -Rf $(CURDIR)/configure
-	rm -Rf $(CURDIR)/gdb-7.6
+	rm -Rf $(CURDIR)/gdb-10.2
 	rm -Rf $(CURDIR)/gdb.files
 	rm -Rf $(CURDIR)/build_data.c
 	rm -Rf $(CURDIR)/extensions/*.so

## crash 8.0.2

=== debian/changelog ===
crash (8.0.2-1) unstable; urgency=medium
  * New upstream
  * commit f1cd581d1c4afa5b8ffdfaa6a3ea9f545fe4ec91
  * Author: Kazuhito Hagio <k-hagio-ab@nec.com>
  * Date:   Wed Nov 16 13:13:39 2022 +0900
  * 
  *     crash-8.0.1 -> crash-8.0.2
  *     
  *     Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit a158590f475c8d6d504b0c5e28b3cd91cfd47877
  * Author: Lianbo Jiang <lijiang@redhat.com>
  * Date:   Wed Nov 9 14:21:57 2022 +0800
  * 
  *     Fix for "ps/vm" commands to display correct %MEM and RSS values
  *     
  *     The ps/vm commands may print the bogus value of the %MEM and RSS, the
  *     reason is that the counter of rss stat is updated in asynchronous manner
  *     and may become negative, when the SPLIT_RSS_COUNTING is enabled in
  *     kernel.
  *     
  *     As a result, crash will read it from memory and convert from negative to
  *     unsigned long integer, eventually it overflows and gets a big integer.
  *     For example:
  *     
  *       crash> ps 1393
  *           PID    PPID  CPU       TASK        ST  %MEM      VSZ      RSS  COMM
  *          1393       1  24  ffff9584bb542100  RU  541298032135.9     4132 18014398509481908  enlinuxpc64
  *                                                  ^^^^^^^^^^^^^^          ^^^^^^^^^^^^^^^^^
  *     
  *     This is unexpected, crash needs to correct its value for this case.
  *     
  *     Signed-off-by: Lianbo Jiang <lijiang@redhat.com>
  * 
  * commit 21139d9456ee41ffc8cec804dc530d6934ddac89
  * Author: Matias Ezequiel Vara Larsen <matiasevara@gmail.com>
  * Date:   Mon Oct 24 11:35:29 2022 +0200
  * 
  *     Fix segmentation fault in page_flags_init_from_pageflag_names()
  *     
  *     When read_string() fails in page_flags_init_from_pageflag_names(),
  *     error() dereferences the name variable to print the string that the
  *     variable points to. However, name points to a string that is not in
  *     crash's memory-space thus triggering a segmentation fault.
  *     
  *     This patch replaces "%s" in the error message with "%lx" so the address
  *     is printed instead.  Also replaces "%ld" for mask with "%lx".
  *     
  *     [ kh: changed the conversion specifiers and commit message ]
  *     
  *     Signed-off-by: Matias Ezequiel Vara Larsen <matias.vara@vates.fr>
  *     Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit 487551488b15fcd135b29990593699a121730219
  * Author: Lianbo Jiang <lijiang@redhat.com>
  * Date:   Tue Oct 4 18:57:11 2022 +0800
  * 
  *     ppc64: still allow oneto move on if the emergency stacks info fails to
  *     initialize
  *     
  *     Currently crash will fail and then exit, if the initialization of
  *     the emergency stacks information fails. In real customer environments,
  *     sometimes, a vmcore may be partially damaged, although such vmcores
  *     are rare. For example:
  *     
  *       # ./crash ../3.10.0-1127.18.2.el7.ppc64le/vmcore
  *       ../3.10.0-1127.18.2.el7.ppc64le/vmlinux  -s
  *       crash: invalid kernel virtual address: 38  type:
  *       "paca->emergency_sp"
  *       #
  *     
  *     Lets try to keep loading vmcore if such issues happen, so call
  *     the readmem() with the RETURN_ON_ERROR instead of FAULT_ON_ERROR,
  *     which allows the crash move on.
  *     
  *     Reported-by: Dave Wysochanski <dwysocha@redhat.com>
  *     Signed-off-by: Lianbo Jiang <lijiang@redhat.com>
  * 
  * commit 3b5e3e1583a1f596360c04e8a322e30cf88f27ab
  * Author: Tao Liu <ltao@redhat.com>
  * Date:   Mon Sep 19 17:49:23 2022 +0800
  * 
  *     Let "kmem" print task context with physical address
  *     
  *     Patch [1] enables "kmem" to print task context if the given virtual
  *     address is a vmalloced stack.
  *     
  *     This patch lets "kmem" print task context also when the given address
  *     is a physical address.
  *     
  *     Before:
  *         crash> kmem 1883700e28
  *            VMAP_AREA         VM_STRUCT                 ADDRESS RANGE                SIZE
  *         ffff94eb9102c640  ffff94eb9102b140  ffffb7efce9b8000 - ffffb7efce9bd000    20480
  *     
  *               PAGE         PHYSICAL      MAPPING       INDEX CNT FLAGS
  *         ffffdd28220dc000 1883700000                0        0  1 50000000000000
  *     
  *     After:
  *         crash> kmem 1883700e28
  *             PID: 847
  *         COMMAND: "khungtaskd"
  *            TASK: ffff94f8038f4000  [THREAD_INFO: ffff94f8038f4000]
  *             CPU: 72
  *           STATE: TASK_RUNNING (PANIC)
  *     
  *            VMAP_AREA         VM_STRUCT                 ADDRESS RANGE                SIZE
  *         ffff94eb9102c640  ffff94eb9102b140  ffffb7efce9b8000 - ffffb7efce9bd000    20480
  *     
  *               PAGE         PHYSICAL      MAPPING       INDEX CNT FLAGS
  *         ffffdd28220dc000 1883700000                0        0  1 50000000000000
  *     
  *     [1]: https://listman.redhat.com/archives/crash-utility/2022-September/010115.html
  *     
  *     [ kh: squashed the 4/4 patch into 3/4 ]
  *     
  *     Signed-off-by: Tao Liu <ltao@redhat.com>
  *     Signed-off-by: Kazuhito Hagio <k-hagio-ab@nec.com>
  * 
  * commit 60cb8650a0126abda661c44d198ebde514eca3e2
  * Author: Tao Liu <ltao@redhat.com>
  * Date:   Mon Sep 19 17:49:22 2022 +0800
  * 
  *     Fix page offset issue when converting physical to virtual address
  *     
  *     When trying to convert a physical address to its virtual
  *     address in dump_vmap_area() and dump_vmlist(), the vi->retval
  *     is added by 2 values: the page aligned address "pcheck"
  *     and page offset address "PAGEOFFSET(paddr)".
  *     
  *     However "paddr" is given by "pcheck", is also page aligned,
  *     so "PAGEOFFSET(paddr)" is always 0.
  *     
  *     In this patch, we will use PAGEOFFSET(vi->spec_addr) to give the
  *     page offset, vi->spec_addr is the physical address we'd like
  *     to convert, which contains the correct page offset.


=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: crash
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
+Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
 Build-Depends: debhelper (>= 13), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev, libzstd-dev, texinfo
 Standards-Version: 4.5.1.0

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 export DEB_BUILD_HARDENING=1
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export EXTDIR=/usr/lib/crash/extensions
 DPKG_EXPORT_BUILDFLAGS=1
 include /usr/share/dpkg/buildflags.mk
